
Enduro/X Core - Bug #133

Client processes don't get killed on "xadmin down"

05/03/2017 10:36 AM - Pablo

Status: Closed Start date: 05/03/2017

Priority: High (Code 3) Due date:  

Assignee:  % Done: 100%

Category:  Estimated time: 0.00 hour

Target version:    

Description

I have client registered in ndrxconfig.xml:

        </servers>

        <clients>

                <client cmdline="brisoncl -t ${NDRX_CLTTAG} -s ${NDRX_CLTSUBSECT}">

                        <exec tag="BRISONCL" subsect="1" autostart="Y" log="${MOSTDIR}/tmp/BRISONCL"/>

                </client>

                <client cmdline="xwfdmn -t XWFDMN -s 1">

                        <exec tag="XWFDMN" subsect="1" autostart="Y" log="/most/runtime/project/a/tmp/XWFDMN"/>

                </client>

                <client cmdline="rmsrepairdmn -t ${NDRX_CLTTAG}">

                        <exec tag="RMSREPAIRDMN" autostart="Y" log="/most/runtime/project/a/tmp/RMSREPAIRDMN"/>

                </client>

        </clients>

</endurox>

they keep running after I run xadmin down and all servers get killed.

History

#1 - 05/03/2017 10:39 AM - Madars

down works only on servers. It does not recognize client processes. But I will think about having to discover the child processes of the CPMSRV. So

that down script, find cpmsrv, checks it's pid, then search for all child processes of this pid and kill them.

#2 - 05/03/2017 10:45 AM - Madars

So we need a way to list child PIDs of the parent pid for:

- Linux: For linux: ps --ppid <PID>

- Solaris

- FreeBSD

- AIX

- Possibly for Cygwin.

Or... probably we could add some sort of filter for ndrx_sys_ps_list(), to check the second column of the ps output. To match the third column to some

value (which is parent process pid). Regex match would be fine.

#3 - 05/03/2017 11:11 AM - Madars

Second option is at point of removal of client queues, we have pid inside, parse the PID and kill the process.

I guess both options would be the best: kill processes for which cpmsrv is parent, and kill any client processes found in queue names.
#4 - 05/03/2017 11:12 AM - Madars

- Priority changed from Normal (Code 4) to High (Code 3)

#5 - 05/26/2017 07:34 AM - Madars

Enduro/X is already killing clients by client reply queue. Thus needs to implement to kill child processes of the cpmsrv.

#6 - 05/28/2017 08:06 AM - Madars

- Status changed from New to Resolved

- % Done changed from 0 to 100

#7 - 05/28/2017 08:09 AM - Madars

New features comes with down:

- Recursively will track down client process childs and kill them too.

- Changed order of killing flow, so that ndrxd or tprecover or cpmsrv does not get chance to boot child processes again

Updates to cpmsrv:

- Added new flag "klevel" with default value 0. Values: 0 - do not kill child processes of the clients Recursively, 1 - kill only when doing SIGKILL (-9), 2

- kill when ever process is being stopped with SIGTERM or SIGINT. For case -2 the child are killed immediately after the signal delivery.

#8 - 05/28/2017 08:10 AM - Madars

- Status changed from Resolved to Closed
